﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace ProvaUtraGrid
{
    public partial class Form1 : Form
    {
        DataSet1 ds = new DataSet1();

        public Form1()
        {
            InitializeComponent();

            InitDataSet();

            ultraGrid1.DataSource = ds;
            ultraGrid1.DataMember = "DataTable1";

            ultraGrid1.Rows.ExpandAll(true);
        }

    

        private void InitDataSet()
        {
            DataSet1.DataTable1Row r1 = ds.DataTable1.AddDataTable1Row("Testata ordine.doc", "c:\\documenti", 1, "descrizione");
           
            DataSet1.DataTable2Row d1 = ds.DataTable2.AddDataTable2Row(r1, 1, "descrizione");
            DataSet1.DataTable2Row d2 = ds.DataTable2.AddDataTable2Row(r1, 1, "descrizione");

            DataSet1.DataTable3Row a1 = ds.DataTable3.AddDataTable3Row(d1, 1, "descrizione");
            DataSet1.DataTable3Row a2 = ds.DataTable3.AddDataTable3Row(d2, 1, "descrizione");
            DataSet1.DataTable3Row a3 = ds.DataTable3.AddDataTable3Row(d2, 1, "descrizione");
            

            ds.DataTable4.AddDataTable4Row(a1, 1, "descrizione");
            ds.DataTable4.AddDataTable4Row(a1, 1, "descrizione");
            ds.DataTable4.AddDataTable4Row(a2, 1, "descrizione");
            ds.DataTable4.AddDataTable4Row(a2, 1, "descrizione");
            ds.DataTable4.AddDataTable4Row(a3, 1, "descrizione");
            ds.DataTable4.AddDataTable4Row(a3, 1, "descrizione");
          
        }

     
       
        private void ultraGrid1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter)
            {
                ultraGrid1.PerformAction(UltraGridAction.ExitEditMode);
                ultraGrid1.PerformAction(UltraGridAction.CommitRow);
            }
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[1].Columns["quantity"].EditorControl = ultraNumericEditor1;
            e.Layout.Bands[2].Columns["quantity"].EditorControl = ultraNumericEditor1;
            e.Layout.Bands[3].Columns["quantity"].EditorControl = ultraNumericEditor1;
        }

        private void ultraGrid1_AfterExitEditMode(object sender, EventArgs e)
        {
            Random r = new Random();
            ultraGrid1.ActiveRow.Cells["descrizione"].Value = "descrizione " + r.Next().ToString();

            //ultraGrid1.BeginUpdate();
            //ultraGrid1.SuspendRowSynchronization();

            UltraGridRow row = ultraGrid1.ActiveRow;

            // 1. 
            // grid scroll up
            while (row.ParentRow != null)
            {
                row = row.ParentRow;

                DataRow dr = ((DataRowView)row.ListObject).Row;
                if (dr != null)
                    dr["descrizione"] = "descrizione " + r.Next().ToString();
            }

            // 2. 
            // grid scroll up if row.Update()
            /*
            while (row.ParentRow != null)
            {
                row = row.ParentRow;
                
                row.Cells["descrizione"].Value = "descrizione " + r.Next().ToString();

                // row.Update();
            }
             */

            //ultraGrid1.ResumeRowSynchronization();
            //ultraGrid1.EndUpdate(false);

        }

        
    }
}
